/*
Rozwiązanie prawidłowe, ale program wszystkich filozofów nie jest
identyczny. Filozowfowie parzyści biorą widelce w innej kolejności
jak nieparzyści.
*/

#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include <pthread.h>
#include <semaphore.h>

#define NO_OF_PHIL 5
#define NO_OF_FORKS 5
#define MAX_DEL 4

void *philosopher(void *arg);
pthread_t philosopher_threads_table[NO_OF_PHIL];
sem_t _fork[NO_OF_FORKS];

void think(int i)
{
    int think_time;
    think_time=rand()%MAX_DEL+1;
    printf("PHILOSOPHER %d THINKS...\n",i);
    sleep(think_time);
}

void eat(int i)
{
    int think_time;
    think_time=rand()%MAX_DEL+1;
    printf("PHILOSOPHER %d EATS...\n",i);
    sleep(think_time);
}

void hungry(int i)
{
    printf("PHILOSOPHER %d HUNGRY...\n",i);
}

void *philosopher(void *arg)
{
    int phil_no;
    phil_no=( int)((int *) arg);

    printf("Philosopher %d started\n",phil_no);
    sleep(0);
    while(1)
    {
        if(phil_no%2) // parzyści
        {
            think(phil_no);
            hungry(phil_no);
            sem_wait(&_fork[phil_no]);
                printf("Philosopher %d has one\n",phil_no);
            sem_wait(&_fork[(phil_no+1)%NO_OF_FORKS]);
                printf("Philosopher %d has two\n",phil_no);
            eat(phil_no);
            sem_post(&_fork[(phil_no+1)%NO_OF_FORKS]);
            sem_post(&_fork[phil_no]);
        }
        else //nieparzyści
        {
            think(phil_no);
            hungry(phil_no);
            sem_wait(&_fork[(phil_no+1)%NO_OF_FORKS]);
                printf("Philosopher %d has one\n",phil_no);
            sem_wait(&_fork[phil_no]);
                printf("Philosopher %d has two\n",phil_no);
            eat(phil_no);
            sem_post(&_fork[phil_no]);
            sem_post(&_fork[(phil_no+1)%NO_OF_FORKS]);
        }
    }
}

int main()
{
    int i,res;
    void *thread_result;
    srand((unsigned) time(NULL));
    for(i=0;i<NO_OF_FORKS;i++)
    {
        res = sem_init(&_fork[i], 0, 1);
        if (res != 0) {
            perror("Semaphore initialization failed\n");
            exit(EXIT_FAILURE);
        }
    }
    // philosophers:
    for(i=0;i<NO_OF_PHIL;i++)
    { res = pthread_create(&philosopher_threads_table[i],
                             NULL,
                             philosopher,
                             (void *) i);
    if (res != 0) {
        perror("Philosopher creation failed\n");
        exit(EXIT_FAILURE);
    }}

    for(i=0;i<NO_OF_PHIL;i++)
    {
        res = pthread_join(philosopher_threads_table[i], &thread_result);
    if (res != 0) {
        perror("Thread join failed\n");
        exit(EXIT_FAILURE);
    }}
    printf("Thread joined\n");
    for(i=0;i<NO_OF_FORKS;i++)
    {
        sem_destroy(&_fork[i]);
    }

    exit(EXIT_SUCCESS);
}
