#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

void *thread_function(void *arg);
pthread_spinlock_t *blokada;

int main() {
    int res;
    pthread_t a_thread;
    void *thread_result;

    blokada = (pthread_spinlock_t *)malloc(sizeof(pthread_spinlock_t));
    res = pthread_spin_init(blokada,PTHREAD_PROCESS_SHARED);

    if (res != 0) {
        perror("Spinlock initialization failed");
        exit(EXIT_FAILURE);
    }
    res = pthread_create(&a_thread, NULL, thread_function, NULL);
    if (res != 0) {
        perror("Thread creation failed");
        exit(EXIT_FAILURE);
    }
    while(1)
    {
        pthread_spin_lock(blokada);
        printf("Spin lock taken by thread 1...\n");
        sleep(5);
        pthread_spin_unlock(blokada);
        printf("Spin lock released by thread 1...\n");
        sleep(3);
    }

    pthread_spin_destroy(blokada);

    res = pthread_join(a_thread, &thread_result);
    if (res != 0) {
        perror("Thread join failed");
        exit(EXIT_FAILURE);
    }
    printf("Thread joined\n");

    exit(EXIT_SUCCESS);
}

void *thread_function(void *arg) {
    int res;
    sleep(1);
    while(1)
    {
        res = pthread_spin_trylock(blokada);
        if(res != 0)
        {
            printf("Spin lock busy...\n");
            sleep(1);
        }
        else
        {
            printf("Spin lock taken by thread 2...\n");
            sleep(1);
            pthread_spin_unlock(blokada);
            printf("Spin lock released by thread 2...\n");
            sleep(1);
        }

    }
    pthread_exit(0);
}
