#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>

void *reader_thread_fun(void *arg);
void *writer_thread_fun(void *arg);
pthread_mutex_t x;
//pthread_mutex_t wsem;
sem_t wsem;
int shared_data;
int readcount;
#define N_READERS 3
#define N_WRITERS 1

int main()
{
    int i,res;
    pthread_t readers_threads_table[10];
    pthread_t writers_threads_table[10];
    void *thread_result;
    readcount=0;
    shared_data=0;
    res = pthread_mutex_init(&x, NULL);
    if (res != 0) {
        perror("Mutex initialization failed");
        exit(EXIT_FAILURE);
    }
    //res = pthread_mutex_init(&wsem, NULL);
    res = sem_init(&wsem, 0, 1);
    if (res != 0) {
        perror("Semaphore initialization failed");
        exit(EXIT_FAILURE);
    }
    // readers:
    for(i=0;i<N_READERS;i++)
    { res = pthread_create(&readers_threads_table[i],
                             NULL,
                             reader_thread_fun,
                             (void *) i);
    if (res != 0) {
        perror("Thread creation failed");
        exit(EXIT_FAILURE);
    }}
    // writers:
    for(i=0;i<N_WRITERS;i++)
    { res = pthread_create(&writers_threads_table[i],
                             NULL,
                             writer_thread_fun,
                             (void *) i);
    if (res != 0) {
        perror("Thread creation failed");
        exit(EXIT_FAILURE);
    }}
    for(i=0;i<N_READERS;i++)
    {
        res = pthread_join(readers_threads_table[i], &thread_result);
    if (res != 0) {
        perror("Thread join failed");
        exit(EXIT_FAILURE);
    }}
    for(i=0;i<N_WRITERS;i++)
    {
    res = pthread_join(writers_threads_table[i], &thread_result);
    if (res != 0) {
        perror("Thread join failed");
        exit(EXIT_FAILURE);
    }}
    printf("Thread joined\n");
    pthread_mutex_destroy(&x);
    //pthread_mutex_destroy(&wsem);
    sem_destroy(&wsem);
    exit(EXIT_SUCCESS);
}

void *reader_thread_fun(void *arg) {
    int data_read;
    printf("Reader %d started...\n",(int) ((int *) arg));
    sleep(1);
    while(1)
    {   pthread_mutex_lock(&x);
            readcount++;
            if(readcount==1) //pthread_mutex_lock(&wsem);
                             sem_wait(&wsem);
            printf("Readcount=%d\n",readcount);
        pthread_mutex_unlock(&x);
        data_read=shared_data;
        printf("Reader %d  consumed %d.\n",(int) ((int *) arg),data_read);
        pthread_mutex_lock(&x);
            readcount--;
            printf("Readcount=%d\n",readcount);
            if(readcount==0) //pthread_mutex_unlock(&wsem);
                            sem_post(&wsem);
        pthread_mutex_unlock(&x);
        sleep(1);
    }
    pthread_exit(0);
}

void *writer_thread_fun(void *arg) {

    printf("Writer %d started...\n",(int) ((int *) arg));
    sleep(1);
    while(1)
    {   //pthread_mutex_lock(&wsem);
        sem_wait(&wsem);
            shared_data++;
        //pthread_mutex_unlock(&wsem);
        sem_post(&wsem);
        sleep(3);
    }
    pthread_exit(0);
}

